AsyncThread : Thread {
	var args, completionFunction, abortFunction;
	var realThread, realParentThread, <result;

	*new {
		arg aFunction, someArgs, aCompletionFunction, anAbortFunction;
		^super.new(aFunction).initAsyncThread(someArgs, aCompletionFunction, anAbortFunction)
	}
	initAsyncThread {
		arg someArgs, aCompletionFunction, anAbortFunction;

		args = someArgs;
		completionFunction = aCompletionFunction;
		abortFunction = anAbortFunction;

		realThread = nil;
		realParentThread = nil;
	}

	resume {
		arg value;
		_AsyncThread_Resume
		this.primitiveFailed
	}

	abort { ^abortFunction.value }
	started { ^(state > 0) }

	prStart {
		result = func.valueArray(args);
		completionFunction.value(result);

		Async.exit;
	}
}
