GtkMultiSpectrumView : GtkScrolledWindow {
	var <views, box;
	*new {
		arg m, n;
		^super.new.initGtkSpectrumPairView(m, n)
	}
	initGtkSpectrumPairView {
		arg m, n;

		views = Array.fill(m, { GtkSpectrumView(n) });
		box = GtkVBox.new;
		views.do({ |view| box.packStart(view, false, false) });
		box.showChildren;

		this.addWithViewport(box.show);
		this.setPolicy(\never, \automatic);

		this.showChildren;
	}

	n { ^views[0].n }
	m { ^views.size }
	at { |i| ^views[i] }
}
