GtkPlusCheckButton : GtkCheckButton {
	*new {
		arg label, action, value = false, signalOnInit = false;
		^super.newWithLabel(label).initGtkPlusCheckButton(action, value, signalOnInit)
	}
	initGtkPlusCheckButton {
		arg action, value, signalOnInit;
		if (signalOnInit.not, { this.setActive(value) });
		this.connect('clicked', { action.value(this.getActive) });
		if (signalOnInit, { this.setActive(value) });
	}

	value { ^this.getActive }
}