GdkColor {
	var <red, <green, <blue;	
	classvar white, red;

	*red {
		red = red ?? { this.newFromNorm(1.0, 0.0, 0.0) }
		^red
	}
	*white {
		white = white ?? { this.newFromNorm(1.0, 1.0, 1.0) }
		^white
	}

	*newFromNorm {
		arg nred = 0.0, ngreen = 0.0, nblue = 0.0;
		^super.new.initFromNorm(nred, ngreen, nblue);
	}
	initFromNorm {
		arg nred, ngreen, nblue;

		nred = nred ? 0.0;
		ngreen = ngreen ? 0.0;
		nblue = nblue ? 0.0;

		red = (nred.clip(0.0, 1.0) * 65535).asInteger;
		green = (ngreen.clip(0.0, 1.0) * 65535).asInteger;
		blue = (nblue.clip(0.0, 1.0) * 65535).asInteger;
	}

	*new {
		arg inRed, inGreen, inBlue;
		^super.new.initGdkColor(inRed, inGreen, inBlue)
	}
	initGdkColor {
		arg inRed, inGreen, inBlue;

		if (inRed.isNil || inGreen.isNil || inBlue.isNil, {
			"Attempt to create a GdkColor instance with nil components".warn;
		});

		red = inRed ? 0.0;
		green = inGreen ? 0.0;
		blue = inBlue ? 0.0;
	}

/*
	*new {
		arg red = 0.0, green = 0.0, blue = 0.0;
		^super.new.init(red, green, blue);
	}
	init {
		arg red = 0.0, green = 0.0, blue = 0.0;
		_prGdkColorNew;
		^this.primitiveFailed
	}
	initFromString {
		arg name = "black";
		_prGdkColorNewFromString;
		^this.primitiveFailed
	}
*/
}
