GdkDrawable : GObject {
	drawRectangle {
		arg gc, filled, x, y, w, h;
		this.drawRectangle_request(gc, filled, x, y, w, h);
		Async.wait
	}
	drawRectangle_request {
		arg gc, filled, x, y, w, h;
		_prGdkDrawableDrawRectangle;
		^this.primitiveFailed
	}

	drawArc {
		arg gc, filled, x, y, w, h, angle1, angle2;
		this.drawArc_request(gc, filled, x, y, w, h, angle1, angle2);
		Async.wait
	}
	drawArc_request {
		arg gc, filled, x, y, w, h, angle1, angle2;
		_prGdkDrawableDrawArc;
		^this.primitiveFailed
	}

	drawLayout {
		arg gc, x, y, layout;
		this.drawLayout_request(gc, x, y, layout);
		Async.wait
	}
	drawLayout_request {
		arg gc, x, y, layout;
		_prGdkDrawableDrawLayout;
		^this.primitiveFailed
	}

	drawLine {
		arg gc, x1, y1, x2, y2;
		this.drawLine_request(gc, x1, y1, x2, y2);
		Async.wait
	}
	drawLine_request {
		arg gc, x1, y1, x2, y2;
		_prGdkDrawableDrawLine;
		^this.primitiveFailed
	}

	drawPoint {
		arg gc, x, y;
		this.drawPoint_request(gc, x, y);
		Async.wait
	}
	drawPoint_request {
		arg gc, x, y;
		_prGdkDrawableDrawPoint;
		^this.primitiveFailed
	}

	getSize {
		var sizes;
		// BUG FIX
		sizes = [];
		while({sizes.size == 0}, {
			this.getSize_request;
			sizes = Async.wait;
		});
		^sizes
	}
	getSize_request {
		_prGdkDrawableGetSize;
		^this.primitiveFailed
	}
}
