GdkGC : GObject {
	*new {
		arg drawable;
		^super.new.initWithNewObject(drawable)
	}
     	initWithNewObject {
		arg drawable;
		this.newGdkGC_request(drawable);
		this.wrap(Async.wait);
	}
	newGdkGC_request {
		arg drawable;
		_prGdkGCNew;
		^this.primitiveFailed
	}

	setRgbFgColorByName {
		arg name;
		this.setRgbFgColorByName_request(name);
		Async.wait;
	}
	setRgbFgColorByName_request {
		arg name;
		_prGdkGCSetRgbFgColorByName;
		^this.primitiveFailed
	}

	setRgbBgColorByName {
		arg name;
		this.setRgbBgColorByName_request(name);
		Async.wait;
	}
	setRgbBgColorByName_request {
		arg name;
		_prGdkGCSetRgbBgColorByName;
		^this.primitiveFailed
	}

	setLineAttributes {
		arg width, style, cap, join;
		this.setLineAttributes_request(width, style, cap, join);
		Async.wait;
	}
	setLineAttributes_request {
		arg width, style, cap, join;
		_prGdkGCSetLineAttributes
		^this.primitiveFailed
	}

	setRgbFgColor {
		arg color;
		if (color.isString, {
			^this.setRgbFgColorByName(color)
		}, {
			this.setRgbFgColor_request(color);
			Async.wait;
		});
	}
	setRgbFgColor_request {
		arg color;
		_prGdkGCSetRgbFgColor;
		^this.primitiveFailed
	}

	setRgbBgColor {
		arg color;
		if (color.isString, {
			^this.setRgbBgColorByName(color)
		}, {
			this.setRgbBgColor_request(color);
			Async.wait;
		});
	}
	setRgbBgColor_request {
		arg color;
		_prGdkGCSetRgbBgColor;
		^this.primitiveFailed
	}
}
