GBoxed {
	classvar <>disableFreeMethod;

	var <ptr;	// Do not add anything before this
	var <type;	// Do not add anything before this
	var <borrowed;	// Do not add anything before this
	var finalizer;	// Do not add anything before this

	*initClass {
		disableFreeMethod = false;
	}

	copy {
		this.copy_request;
		^Async.wait
	}
	copy_request {
		_prGBoxedCopy;
		GObject.asyncPrimitiveFailed
	}

	*wrap {
		arg ptr0, type0, borrowed = false;
		_prGBoxedWrap;
		GObject.asyncPrimitiveFailed
	}

	*newEmpty {
		^super.new.initEmpty;
	}

	*registerWrapperClass {
		arg typename;
		_prGBoxedRegisterWrapperClass;
		^this.primitiveFailed
	}

	initEmpty {
		this.storage = nil;
	}

	isValid {
		^((ptr != 0) && (type != 0))
	}

	disableFinalizer {
		borrowed = true;
	}
	steal {
		this.disableFinalizer;
		^ptr
	}
}
