GtkColorSelection : GtkVBox {
	initWithNewObject {
		this.newGtkColorSelection_request;
		^this.wrap(Async.wait)
	}
	newGtkColorSelection_request {
		_prGtkColorSelectionNew;
		^this.primitiveFailed;
	}

	setCurrentColor {
		arg color;
		this.setCurrentColor_request(color);
		Async.wait
	}
	setCurrentColor_request {
		arg color;
		_prGtkColorSelectionSetCurrentColor;
		^this.primitiveFailed
	}

	getCurrentColor {
		var r, g, b;
		this.getCurrentColor_request;
		#r, g, b = Async.wait
		^GdkColor.new(r, g, b)
	}
	getCurrentColor_request {
		_prGtkColorSelectionGetCurrentColor;
		^this.primitiveFailed
	}

	setHasOpacityControl {
		arg color;
		this.setHasOpacityControl_request(color);
		Async.wait
	}
	setHasOpacityControl_request {
		arg color;
		_prGtkColorSelectionSetHasOpacityControl;
		^this.primitiveFailed
	}

	getHasOpacityControl {
		this.getHasOpacityControl_request;
		^Async.wait
	}
	getHasOpacityControl_request {
		_prGtkColorSelectionGetHasOpacityControl;
		^this.primitiveFailed
	}

	setUpdatePolicy {
		arg policy;
		this.setUpdatePolicy_request(policy);
		Async.wait
	}
	setUpdatePolicy_request {
		arg policy;
		_prGtkColorSelectionSetUpdatePolicy;
		^this.primitiveFailed
	}

}
