GtkCombo : GtkHBox {
	initWithNewObject {
		this.newGtkCombo_request;
		this.wrap(Async.wait)
	}
	newGtkCombo_request {
		_prGtkComboNew;
		^this.primitiveFailed;
	}

	setPopdownStrings {
		arg...strings;
		^this.setPopdownStringsList(strings);
	}
	setPopdownStringsList {
		arg strings;
		this.setPopdownStrings_request(strings);
		Async.wait
	}
	setPopdownStrings_request {
		arg strings;
		_prGtkComboSetPopdownStrings;
		^this.primitiveFailed
	}

	setValueInList {
		arg value = true, okIfEmpty = false;
		this.setValueInList_request(value, okIfEmpty);
		Async.wait		
	}
	setValueInList_request {
		arg value, okIfEmpty;
		_prGtkComboSetValueInList;
		^this.primitiveFailed
	}

	setUseArrows {
		arg value;
		this.setUseArrows_request(value);
		Async.wait	
	}
	setUseArrows_request {
		arg value;
		_prGtkComboSetUseArrows;
		^this.primitiveFailed
	}

	setCaseSensitive {
		arg value;
		this.setCaseSensitives_request(value);
		Async.wait	
	}
	setCaseSensitive_request {
		arg value;
		_prGtkComboSetCaseSensitive;
		^this.primitiveFailed
	}

	setItemString {
		arg item, string;
		this.setItemString_request(item, string);
		Async.wait	
	}
	setItemString_request {
		arg item, string;
		_prGtkComboSetItemString;
		^this.primitiveFailed
	}

	disableActivate {
		this.disableActivate_request;
		Async.wait	
	}
	disableActivate_request {
		_prGtkComboDisableActivate;
		^this.primitiveFailed
	}

	entry {
		^GObject.wrap(this.prEntry)
	}
	prEntry {
		_prGtkComboEntry;
		^this.primitiveFailed
	}
	list {
		^GObject.wrap(this.prList)
	}
	prList {
		_prGtkComboList;
		^this.primitiveFailed
	}
}
