GtkEntry : GtkEditable {
	*new {
		arg ...args;
		^super.new.performList(\initWithNewObject, args)
	}
	*newWithRange {
		arg ...args;
		^super.new.performList(\initWithNewObjectWithRange, args)
	}

	initWithNewObject {
		this.newGtkEntry_request;
		this.wrap(Async.wait)
	}
	newGtkEntry_request {
		_prGtkEntryNew;
		^this.primitiveFailed
	}

	setText {
		arg text;
		this.setText_request(text);
		Async.wait
	}
	setText_request {
		arg text;
		_prGtkEntrySetText;
		^this.primitiveFailed
	}

	getText {
		this.getText_request
		^Async.wait
	}
	getText_request {
		_prGtkEntryGetText;
		^this.primitiveFailed
	}

	setEditable {
		arg value = true;
		this.setEditable_request(value);
		Async.wait
	}
	setEditable_request {
		arg value;
		_prGtkEntrySetEditable;
		^this.primitiveFailed
	}
}
