GtkHBox : GtkBox {
	*new {
		arg...args;
		^super.new.performList(\initWithNewObject, args)
	}

	initWithNewObject {
		arg homogeneous = false, spacing = 0;
		this.newGtkHBox_request(homogeneous, spacing);
		this.wrap(Async.wait)
	}
	newGtkHBox_request {
		arg homogeneous = false, spacing = 0;
		_prGtkHBoxNew;
		^this.primitiveFailed;
	}

	// EXTRA
	*qpack {
		arg ...args;
		var box, object, mode;

		box = GtkHBox.new;
		(args.size / 2).asInteger.do({
			arg i;
			object = args[i * 2];
			mode = args[(i * 2) + 1];
			box.packStart(object, mode, mode);
		});
		box.showAllChildren;
		^box
	}
}
