GtkListStore : GtkTreeModel {
	*new {
		arg ... types;
		if (types.size == 0, { types = [\chararray] });
		this.newGtkListStore_request(types);
		^super.new.wrap(Async.wait)
	}
	*newGtkListStore_request {
		arg types;
		_prGtkListStoreNew;
		^this.primitiveFailed
	}

	append {
		this.append_request;
		^Async.wait;
	}
	append_request {
		_prGtkListStoreAppend;
		this.primitiveFailed
	}

	setValue {
		arg iter, column, type, value;
		this.setValue_request(iter, column, type, value);
		Async.wait
	}
	setValue_request {
		arg iter, column, type, value;
		_prGtkListStoreSetValue;
		this.primitiveFailed
	}

	clear {
		this.clear_request;
		Async.wait
	}
	clear_request {
		_prGtkListStoreClear;
		this.primitiveFailed
	}

	remove {
		arg iter;
		this.remove_request(iter);
		if (Async.wait, {
			^iter
		}, {
			^nil
		});
	}
	remove_request {
		arg iter;
		_prGtkListStoreRemove;
		^this.primitiveFailed
	}
}
