GtkMenu : GtkMenuShell {
	*new {
		this.newGtkMenu_request;
		^super.new.wrap(Async.wait)
	}
	*newGtkMenu_request {
		_prGtkMenuNew;
		^this.primitiveFailed
	}

	popup {
		arg button, time;
		this.popup_request(button, time);
		Async.wait
	}
	popup_request {
		arg button, time;
		_prGtkMenuPopup;
		^this.primitiveFailed
	}

	// Extra
	*newWith {
		arg ...pairs;
		var menu;

		menu = GtkMenu.new;
		menu.appendItems(pairs);
		
		^menu
	}
	prependItems {
		arg pairs;
		^this.prAttachItems(pairs, \prepend);
	}
	appendItems {
		arg pairs;
		^this.prAttachItems(pairs, \append);
	}

	prAttachItems {
		arg pairs, method = \append;		var menuitem;
		pairs.do({
			arg item;
			menuitem = item.asGtkMenuItem;
			this.perform(method, menuitem);
			menuitem.show;
		});
	}
}
