GtkMenuShell : GtkContainer {
	append {
		arg child;
		this.append_request(child);
		Async.wait
	}
	append_request {
		arg child;
		_prGtkMenuShellAppend;
		^this.primitiveFailed
	}

	prepend {
		arg child;
		this.prepend_request(child);
		Async.wait
	}
	prepend_request {
		arg child;
		_prGtkMenuShellPrepend;
		^this.primitiveFailed
	}

	insert {
		arg child, n;
		this.insert_request(child);
		Async.wait
	}
	insert_insert {
		arg child, n;
		_prGtkMenuShellInsert;
		^this.primitiveFailed
	}

	// EXTRA
	newItemAndConnect {
		arg text, callback;
		var item;

		item = GtkMenuItem.newWithLabel(text);
		item.connect("activate", callback);
		this.append(item);
		item.show;
	}
}
