GtkTreeViewColumn : GtkObject {
	*new {
		this.newGtkTreeViewColumn_request;
		^super.new.wrap(Async.wait)
	}
	*newGtkTreeViewColumn_request {
		_prGtkTreeViewColumnNew;
		^this.primitiveFailed;
	}

	*newWithAttributes {
		arg title, renderer ... attributes;
		this.newGtkTreeViewColumnWithAttributes_request(title, renderer, attributes);
		^super.new.wrap(Async.wait)
	}
	*newGtkTreeViewColumnWithAttributes_request {
		arg title, renderer, attributes;
		_prGtkTreeViewColumnNewWithAttributes;
		^this.primitiveFailed;
	}

	setClickable {
		arg value = true;
		this.setClickable_request(value);
		Async.wait
	}
	setClickable_request {
		arg value;
		_prGtkTreeViewColumnSetClickable;
		^this.primitiveFailed;
	}

	setSizing {
		arg mode = 'autosize';
		this.setSizing_request(mode);
		Async.wait
	}
	setSizing_request {
		arg mode;
		_prGtkTreeViewColumnSetSizing;
		^this.primitiveFailed;
	}

	setFixedWidth {
		arg value;
		this.setFixedWidth_request(value);
		Async.wait
	}
	setFixedWidth_request {
		arg value;
		_prGtkTreeViewColumnSetFixedWidth;
		^this.primitiveFailed;
	}

	setTitle {
		arg title;
		this.setTitle_request(title);
		Async.wait
	}
	setTitle_request {
		arg title;
		_prGtkTreeViewColumnSetTitle;
		^this.primitiveFailed
	}
}
