GtkWidget : GtkObject {
	setSizeRequest {
		arg w = -1, h = -1;
		this.setSizeRequest_request(w, h);
		Async.wait
	}
	setSizeRequest_request {
		arg w = -1, h = -1;
		_prGtkWidgetSetSizeRequest;
		^this.primitiveFailed
	}

	getSizeRequest {
		this.getSizeRequest_request;
		^Async.wait
	}
	getSizeRequest_request {
		_prGtkWidgetGetSizeRequest;
		^this.primitiveFailed
	}

	show {
		this.show_request;
		Async.wait
	}
	show_request {
		_prGtkWidgetShow;
		^this.primitiveFailed
	}

	showAll {
		this.showAll_request;
		Async.wait
	}
	showAll_request {
		_prGtkWidgetShowAll;
		^this.primitiveFailed
	}

	hide {
		this.hide_request;
		Async.wait
	}
	hide_request {
		_prGtkWidgetHide;
		^this.primitiveFailed
	}

	hideAll {
		this.hideAll_request;
		Async.wait
	}
	hideAll_request {
		_prGtkWidgetHideAll;
		^this.primitiveFailed
	}

	destroy {
		if (ptr.notNil, {
			this.destroy_request;
			Async.wait
		});
	}
	destroy_request {
		_prGtkWidgetDestroy;
		^this.primitiveFailed
	}

	addEvents {
		arg events;
		this.addEvents_request(events);
		Async.wait
	}
	addEvents_request {
		arg events;
		_prGtkWidgetAddEvents;
		^this.primitiveFailed
	}

	setEvents {
		arg events;
		this.setEvents_sync(events);
		Async.wait
	}
	setEvents_request {
		arg events;
		_prGtkWidgetSetEvents;
		^this.primitiveFailed
	}

	setExtensionEvents {
		arg events;
		this.setExtensionEvents_request(events);
		Async.wait
	}
	setExtensionEvents_request {
		arg events;
		_prGtkWidgetSetExtensionEvents;
		^this.primitiveFailed
	}

	window {
		this.window_request;
		^GObject.wrap(Async.wait)
	}
	window_request {
		_prGtkWidgetWindow;
		^this.primitiveFailed
	}

	getStyle {
		this.getStyle_request;
		^GObject.wrap(Async.wait)
	}
	getStyle_request {
		_prGtkWidgetGetStyle;
		^this.primitiveFailed
	}

	getPangoContext {
		this.getPangoContext_request;
		^GObject.wrap(Async.wait)
	}
	getPangoContext_request {
		_prGtkWidgetGetPangoContext;
		^this.primitiveFailed
	}

	
	queueDraw {
		this.queueDraw_request;
		Async.wait
	}
	queueDraw_request {
		_prGtkWidgetQueueDraw;
		^this.primitiveFailed
	}
	queueResize {
		this.queueResize_request;
		Async.wait
	}
	queueResize_request {
		_prGtkWidgetQueueResize;
		^this.primitiveFailed
	}

	// Flags
	isRealized {
		this.isRealized_request;
		^Async.wait
	}
	isRealized_request {
		_prGtkWidgetIsRealized;
		^this.primitiveFailed
	}

	isMapped {
		this.isMapped_request;
		^Async.wait
	}
	isMapped_request {
		_prGtkWidgetIsMapped;
		^this.primitiveFailed
	}

	isVisible {
		this.isVisible_request;
		^Async.wait
	}
	isVisible_request {
		_prGtkWidgetIsVisible;
		^this.primitiveFailed
	}

	canFocus {
		this.canFocus_request;
		^Async.wait
	}
	canFocus_request {
		_prGtkWidgetCanFocus;
		^this.primitiveFailed
	}

	canFocus_ {
		arg value;
		this.setCanFocus_request(value);
		^Async.wait
	}
	setCanFocus_request {
		arg value;
		_prGtkWidgetSetCanFocus;
		^this.primitiveFailed
	}

	isToplevel {
		this.isToplevel_request;
		^Async.wait
	}
	isToplevel_request {
		_prGtkWidgetIsToplevel;
		^this.primitiveFailed
	}

	//
	getParent {
		this.getParent_request;
		^GObject.wrap(Async.wait)
	}
	getParent_request {
		_prGtkWidgetGetParent;
		^this.primitiveFailed
	}

	setParent {
		arg container;
		this.setParent_request(container);
		^GObject.wrap(Async.wait)
	}
	setParent_request {
		arg container;
		_prGtkWidgetSetParent;
		^this.primitiveFailed
	}

	unParent {
		this.unParent_request;
		^GObject.wrap(Async.wait)
	}
	unParent_request {
		_prGtkWidgetUnparent;
		^this.primitiveFailed
	}

	getParentWindow {
		this.getParentWindow_request;
		^GObject.wrap(Async.wait)
	}
	getParentWindow_request {
		_prGtkWidgetGetParentWindow;
		^this.primitiveFailed
	}

	getDoubleBuffered {
		this.getDoubleBuffered_request;
		^Async.wait
	}
	getDoubleBuffered_request {
		_prGtkWidgetGetDoubleBuffered;
		^this.primitiveFailed
	}

	setDoubleBuffered {
		arg value = true;
		this.setDoubleBuffered_request(value);
		Async.wait
	}
	setDoubleBuffered_request {
		arg value;
		_prGtkWidgetSetDoubleBuffered;
		^this.primitiveFailed
	}

	grabFocus {
		this.grabFocus_request;
		Async.wait
	}
	grabFocus_request {
		_prGtkWidgetGrabFocus;
		^this.primitiveFailed
	}

	setState {
		arg state;
		this.setState_request(state);
		Async.wait
	}
	setState_request {
		arg state;
		_prGtkWidgetSetState;
		^this.primitiveFailed
	}

	getToplevel {
		this.getToplevel_request;
		^GObject.wrap(Async.wait)
	}
	getToplevel_request {
		_prGtkWidgetGetToplevel;
		^this.primitiveFailed
	}

	getSensitive {
		this.getSensitive_request;
		^Async.wait
	}
	getSensitive_request {
		_prGtkWidgetGetSensitive;
		^this.primitiveFailed
	}

	setSensitive {
		arg value = true;
		this.setSensitive_request(value);
		Async.wait
	}
	setSensitive_request {
		arg value;
		_prGtkWidgetSetSensitive;
		^this.primitiveFailed
	}

	modifyBg {
		arg state, color;
		this.modifyBg_request(state, color);
		Async.wait
	}
	modifyBg_request {
		arg state, color;
		_prGtkWidgetModifyBg;
		^this.primitiveFailed
	}

	reparent {
		arg newParent;
		this.reparent_request(newParent);
		Async.wait
	}
	reparent_request {
		arg reparent;
		_prGtkWidgetReparent;
		^this.primitiveFailed
	}

	// Extra

	defaultSizeAsToplevel {	^#[800, 600] }
	needsScrolledWindow { ^false }

	asToplevel {
		arg w, h, title, scrolled;
		var window, w0, h0, child;

		scrolled = scrolled ? this.needsScrolledWindow;

		#w0, h0 = this.defaultSizeAsToplevel;

		if (scrolled, {
			child = GtkScrolledWindow.new;
			child.setPolicy(\automatic, \automatic);
			child.add(this);
			this.show;
		}, {
			child = this;
		});

		window = GtkWindow.new;
		window.setDefaultSize(w ? w0, h ? h0);
		window.setTitle(title ? this.class.asString);

		window.add(child);

		child.show;
		window.show;

		^window
	}

	asGtkFrame {
		arg caption;			var frame;
		frame = GtkFrame(caption);
		frame.add(this);
		this.show;
		^frame
	}
}
