+ Object {
	asGtkMenuItem { ^this.class.asString.asGtkMenuItem }
}

+ Symbol {
	asGtkMenuItem { ^if (this === \separator, { GtkSeparatorMenuItem.new}, { this.asString.asGtkMenuItem }) }
}

+ String {
	asGtkMenuItem { ^GtkMenuItem.newWithLabel(this) }
}

+ Association {
	asGtkMenuItem {
		var menuitem, submenu;
		menuitem = GtkMenuItem.newWithLabel(this.key);
		if (this.value.isKindOf(Function), {
			menuitem.connect('activate', { this.value.value; } );
		}, {
			submenu = this.value.asGtkMenu;
			menuitem.setSubmenu(submenu);
		});
		^menuitem
	}
}
