EventRecorder {
	var <events;
	*new {
		^super.new.initEventRecorder
	}
	initEventRecorder {
		events = List[];
	}
	push { arg data; events.add([thisThread.seconds, data]) }
	playback {
		arg function, evts;
		evts = evts ? events;
		Routine({
			evts.doAdjacentPairs({
				arg curevt, nxtevt, i;
				function.value(curevt[1]);
				(nxtevt[0] - curevt[0]).wait;
			});
			function.value(evts.last[1]);
		}).play(SystemClock);
	}

	clear {	events.clear }
	size { ^events.size }
}
