PrivateBus {
        var rate, channels, bus;

	*initClass {
		Spec.specs['feedBus'] = this.audio
	}

        *new {
		arg rate = \audio, channels = 1;
		^super.newCopyArgs(rate, channels)
        }
        *audio {
		arg channels = 1;
		^this.new(\audio, channels)
        }
        *control {
		arg channels = 1;
		^this.new(\control, channels)
        }

        releaseBus { this.free }
        asBus {}
        index {
		^bus.index
	}
        prepareToBundle {
		arg group, bundle;
		Post << thisMethod.asString << ": allocating bus" << nl;
                bus = Bus.alloc(rate, group.server, channels);
        }
	freeToBundle {
		this.free;
	}
        addToSynthDef {
		arg synthDef,name;
		synthDef.addInstrOnlyArg(name, this.synthArg)
        }
        synthArg {
		^this.index
	}
        rate {
		^\scalar
	}
        instrArgFromControl {
		arg control;
		^this.index
	}
        free {
		Post << thisMethod.asString << ": deallocating bus" << nl;
		bus.free;
		bus = nil;
        }
	defaultControl { nil }
}
