+ Patch {
	controlOf {
		arg name;
		var index, control;

		index = if (name.isNumber, { name }, { this.indexFromName(name) });
		index = this.synthArgsIndices[index];
		if (index.isNil, { ^nil });

		^this.argsForSynth[index]
	}

	directControlOf {
		arg name;
		var object, index, control;

		index = if (name.isNumber, { name }, { this.indexFromName(name) });
		index = this.synthArgsIndices[index];
		if (index.isNil, { ^nil });

		control = NodeControl(synth, index);
		if (name.isNumber.not, { control.name = name });

		^control
	}
}
