GtkClassCodeView : GtkVBox {
	var <classObject, mview, cview;
	
	*new {
		arg classObject;
		^super.new(false, 0).initGtkClassCodeView(classObject);
	}
	initGtkClassCodeView {
		arg aClassObject;
		var paned;

		paned = GtkVPaned.new;
		paned.setPosition(320);
		this.packStart(paned, true, true, 0);

		mview = GtkMethodsListView.new;
		mview.selection.connect('changed', {
			var filename, charNum;

			#filename, charNum = mview.location;
			cview.load(filename, charNum);
		});
		paned.pack1(mview, true, true);

		cview = GtkSCCodeView.new;
		cview.textview.setEditable(false);
		paned.pack2(cview, true, true);

		this.classObject = aClassObject;
	}

	classObject_ {
		arg aClassObject;
		cview.sourceOf(aClassObject);
		mview.classObject = aClassObject;
	}
}
