GtkClassLibraryBrowser : GtkVBox {
	var treeview, classcodeview;

	*new {
		^super.new(false, 0).initGtkClassLibraryBrowser
	}
	initGtkClassLibraryBrowser {
		var paned;

		paned = GtkHPaned.new;
		paned.setPosition(320);
		this.packStart(paned, true, true, 0);

		treeview = GtkClassTreeView.new;
		paned.pack1(treeview, true, true);

		classcodeview = GtkClassCodeView.new;
		paned.pack2(classcodeview, true, true);

		treeview.selection.connect('changed', {
			this.sync;
		});

		this.showAllChildren;
		this.sync;
	}

	sync {
		var iter, name, classObject;

		iter = treeview.selection.getSelected;
		if (iter.notNil, {
			name = treeview.model.getValue(iter, 0);
			classObject = name.asSymbol.asClass;
			classcodeview.classObject = classObject;
		});
	}
}
