GtkSimpleColorSelectionPopup : GtkWindow {
	var <selection;

	*new {
		^super.new.initGtkSimpleColorSelectionPopup
	}
	initGtkSimpleColorSelectionPopup {
		arg color;
		var frame;

		this.setPosition('mouse');
		this.addEvents(['leave-notify-mask', 'button-release-mask']);
		this.connect('button-release-event', {
			arg ...args;
			this.hide
		});
		frame = GtkFrame.new;
		this.add(frame);

		selection = GtkColorSelection.new;
		selection.setCurrentColor(color ?? { GdkColor.red });
		
		frame.add(selection);

		this.showAllChildren(true);
	}
}
