GtkVariableSampleSetSelector : GtkSampleSetSelector {
	var <removeButtons, <addButton;
	*new {
		arg groups, n, action, label;
		^super.new(groups, n, action, label).initGtkVariableSampleSetSelector
	}
	initGtkVariableSampleSetSelector {
		this.replacePackager(\normal, {
			var table, n;

			n = selectors.size;
			table = GtkTable(n + 1, 5);
			table.packArrays(
				removeButtons, [0, 0],
				selectors, [0, 0],
				rndButtons, [0, 0],
				rndInGrpButtons, [0, 0],
				sizeLabels, [0, 0],
				playbackButtons, [0, 0]
			);
			table.attach(addButton.show, 0, 1, n, n + 1);
			table.attach(allRndButton.show, 1, 2, n, n + 1);
			table.attach(allRndInGrpButton.show, 2, 3, n, n + 1);
			
			table
		});

		this.addPackager(\tworows, {
			var table, n;

			n = selectors.size;
			table = GtkTable(2*n, 4);
			n.do({
				arg i;
				table.attach(removeButtons[i], 0, 1, (i*2), (i*2) + 1);
				table.attach(selectors[i], 1, 2, (i*2), (i*2) + 1);
				table.attach(rndButtons[i], 2, 3, (i*2), (i*2) + 1);
				table.attach(rndInGrpButtons[i], 3, 4, (i*2), (i*2) + 1);
				table.attach(sizeLabels[i], 0, 3, (i*2) + 1, (i*2) + 2);
				table.attach(playbackButtons[i], 3, 4, (i*2) + 1, (i*2) + 2);
			});
			table.attach(addButton.show, 0, 1, 2*n, (2*n) + 1);
			table.attach(allRndButton, 2, 3, 2*n, (2*n) + 1);
			table.attach(allRndInGrpButton, 3, 4, 2*n, (2*n) + 1);
			table.showChildren;
			table
		});
	}

	prMakeWidgets {
		arg groups, n;			var button;

		super.prMakeWidgets(groups, n);
		removeButtons = Array.fill(n, {
			arg k;
			button = GtkButton.newWithStockImage('gtk-remove', 'small-toolbar');
			button.connect('clicked', { this.removeSelector(k) });
			button
		});
		this.addAll(removeButtons);
		addButton = GtkButton.newWithStockImage('gtk-add', 'small-toolbar');
		addButton.connect('clicked', { this.addSelector });
		this.add(addButton);
	}

	removeSelector {
	}
	addSelector {
	}
}