TestEmitter {
	var <x, <y, <z;

	x_ {
		arg value;
		x = value;
		this.emit('x-changed', x);
	}
	y_ {
		arg value;
		y = value;
		this.emit('y-changed', y);
	}
	z_ {
		arg value;
		z = value;
		this.emit('z-changed', z);
	}
}

TestReceiver {
	var source;
	*new {
		arg aSource;
		^super.new.initTestReceiver(aSource);
	}
	initTestReceiver {
		arg aSource;

		source = aSource;
		this.watch('x-changed', source, {
			arg value;
			Post << "X is changed. X**2 is " << (value ** 2) << "\n";
		});
		this.watch('z-changed', source, {
			arg value;
			Post << "Z is changed. Z**2 is " << (value ** 2) << "\n";
		});

	}

	finalize {
		this.forget(source);
	}
}
