#include "callableQueue.h"

CallableQueue::CallableQueue(void) {
  message_arrived.connect(SigC::slot(*this, &CallableQueue::on_message_arrived));
}

void CallableQueue::on_message_arrived(Callable *callable) {
  (*callable)();
  delete callable;
}
