// Copyright 2003 Maurizio Umberto Puxeddu

#ifndef _Supercollider_simpleConfigFile_h_
#define _Supercollider_simpleConfigFile_h_

#include <stdio.h>

#include "SC_LibraryConfig.h"

class SimpleConfigFile : public SC_LibraryConfig {
 public:
  SimpleConfigFile(void);
  ~SimpleConfigFile();
  
  static SimpleConfigFile *load(const char *filename);
  static SimpleConfigFile *loadFromStandardPaths(void);

 private:
  bool readFile(const char *filename);
  void parseFile(FILE *file);
};

#endif // _Supercollider_simpleConfigFile_h_
