AudioSeq {
	*ar {
		arg period, duration1, duration2;
		var index, index1, index2, f1, f2;

		duration2 = duration2 ? period - duration1;

		index = LFSaw.ar(period.reciprocal, pi, 0.5, 0.5);

		f1 = duration1 / period;
		index1 = (index.min(f1) / f1);
		
		f2 = (duration1 + duration2) / period;
		index2 = ((index.max(f1).min(f2) - f1) / (f2 - f1));

		^[index1, index2]
	}
}
