GtkEqEnvelope : GtkHBox {
	classvar spec;
	var <envtable, <boostslider;
	*initClass {
		spec = ControlSpec(0.0, 1.0, \exp);
	}
	*new {
		arg size = 64;
		^super.new.initGtkEqEnvelope(size)
	}
	initGtkEqEnvelope {
		arg size;

		envtable = GtkPlusMultiSlider(size, nil, \boostcut.asSpec);
		envtable.showSeparators = false;
		envtable.set(0.0);
		this.packStart(envtable, true, true);

		boostslider = GtkPlus1dSlider("boostcut" -> \boostcut.asSpec, nil, mode: \vertical, inverted: true);
		boostslider.set(0.0);
		this.packStart(boostslider, false, false);

		this.showChildren
	}
	
	level { arg fq; ^(envtable.interp(fq) + boostslider.value) }
}
