GtkPlusToggleButton : GtkHBox {
	var <value, callback, locked = false, button;
	*new {
		arg text1 = "On", text2 = "Off", callback, value = false;
		^super.new.initGtkPlusToggleButton(text1, text2, callback, value)
	}
	initGtkPlusToggleButton {
		arg text1, text2, aCallback, aValue;
		callback = aCallback;
		button = GtkToggleButton.newWithTwoLabels(text1, text2, {
			this.prUpdate(false)
		}, {
			this.prUpdate(true)
		});
		this.set(aValue);
		this.packStart(button, true, true);
		this.showChildren
	}
	value_ {
		arg value;
		button.setActive(value);
	}
	set {
		arg value0;
		locked = true;
		button.setActive(value0);
		value = value0;
		locked = false;
	}
	prUpdate {
		arg value0;
		value = value0;
		if (locked.not, { callback.value(value) });
	}
}
