GtkSpectrumPairView : GtkVBox {
	var <view1, <view2;
	*new {
		arg n;
		^super.new.initGtkSpectrumPairView(n)
	}
	initGtkSpectrumPairView {
		arg n;				var buttonBox, button;

		view1 = GtkSpectrumView(n);
		view2 = GtkSpectrumView(n);

		buttonBox = GtkHBox.new;

		button = GtkTriggerButton("Swap", {
			swap(view1, view2);
		});
		buttonBox.packStart(button, true, true);
		button = GtkTriggerButton("f1 -> f2", {
			view2.freqs = view1.freqs;
		});
		buttonBox.packStart(button, true, true);
		button = GtkTriggerButton("f2 -> f1", {
			view1.freqs = view2.freqs;
		});
		buttonBox.packStart(button, true, true);

		button = GtkTriggerButton("a1 -> a2", {
			view2.amps = view1.amps;
		});
		buttonBox.packStart(button, true, true);
		button = GtkTriggerButton("a2 -> a1", {
			view1.amps = view2.amps;
		});
		buttonBox.packStart(button, true, true);

		buttonBox.showChildren;

		this.packStart(view1);
		this.packStart(view2);
		this.packStart(buttonBox);

		this.showChildren;
	}
	
}
