GtkAdjustment : GtkObject {
	*new {
		arg value = 0.0, lower = 0.0, upper = 1.1, step_increment = 0.001, page_increment = 0.1, page_size = 0.1;
		this.newGtkAdjustment_request(value, lower, upper, step_increment, page_increment, page_size);
		^super.new.wrap(Async.wait).init;
	}
	*newGtkAdjustmentNew_request {
		arg value, lower, upper, step_increment, page_increment, page_size;
		_prGtkAdjustmentNew;
		^this.primitiveFailed;
	}

	getValue {
		this.getValue_request;
		^Async.wait
	}
	getValue_request {
		_prGtkAdjustmentGetValue;
		^this.primitiveFailed;
	}

	setValue {
		arg value;
		this.setValue_request(value);
		^Async.wait
	}
	setValue_request {
		arg value;
		_prGtkAdjustmentSetValue;
		^this.primitiveFailed;
	}


	clampPage {
		arg lower, upper;
		this.clampPage_request(lower, upper);
		^Async.wait
	}
	clampPage_request {
		arg lower, upper;
		_prGtkAdjustmentClampPage;
		^this.primitiveFailed;
	}

	changed {
		this.changed_request;
		Async.wait
	}
	changed_request {
		_prGtkAdjustmentChanged;
		^this.primitiveFailed;
	}
	valueChanged {
		this.valueChanged_request;
		Async.wait
	}
	valueChanged_request {
		_prGtkAdjustmentValueChanged;
		^this.primitiveFailed;
	}

	// Extra

	followWithSpec {
		arg cntlspec, function;

		this.connect("value-changed", {
			arg adjustment;
			function.value(adjustment, cntlspec.map(adjustment.getValue));
		});
	}
}
