GtkEditable : GtkWidget {
	var <>locked = false;

	setEditable {
		arg value;
		this.setEditable_request(value);
		Async.wait
	}
	setEditable_request {
		arg value;
		_prGtkEditableSetEditable;
		^this.primitiveFailed
	}

	getEditable {
		this.getEditable_request;
		^Async.wait
	}
	getEditable_request {
		_prGtkEditableGetEditable;
		^this.primitiveFailed
	}

	// EXTRA
	setClickToEdit {
		this.setProperty('can-focus', false);
		this.setProperty('editable', false);
		this.connect('button-release-event', {
			if (this.locked.not, {
				this.setProperty('can-focus', true);
				this.setProperty('editable', true);
				this.grabFocus;
			});
		});
		this.connect('activate', {
			this.setProperty('can-focus', false);
			this.setProperty('editable', false);
			this.getToplevel.setFocus;
		});
	}
}
