GtkSpinButton : GtkEntry {
	initWithNewObject {
		arg adjustment, climbRate, digits;
		this.newGtkSpinButton_request;
		this.wrap(Async.wait)
	}
	newGtkSpinButton_request {
		arg adjustment, climbRate, digits;
		_prGtkSpinButtonNew;
		^this.primitiveFailed
	}

	initWithNewObjectWithRange {
		arg min, max, step;
		this.newGtkSpinButtonWithRange_request(min, max, step);
		this.wrap(Async.wait)
	}
	newGtkSpinButtonWithRange_request {
		arg min, max, step;
		_prGtkSpinButtonNewWithRange;
		^this.primitiveFailed
	}

	setAdjustment {
		arg adjustment;
		this.setAdjustment_request(adjustment);
		Async.wait
	}
	setAdjustment_request {
		arg adjustment;
		_prGtkSpinButtonSetAdjustment;
		^this.primitiveFailed
	}

	getAdjustment {
		this.getAdjustment_request;
		^GObject.wrap(Async.wait)
	}
	getAdjustment_request {
		_prGtkSpinButtonGetAdjustment;
		^this.primitiveFailed
	}

	setDigits {
		arg n;
		this.setDigits_request(n);
		Async.wait
	}
	setDigits_request {
		arg n;
		_prGtkSpinButtonSetDigits;
		^this.primitiveFailed
	}

	setIncrements {
		arg step, page;
		this.setIncrements_request(step, page);
		Async.wait
	}
	setIncrements_request {
		arg step, page;
		_prGtkSpinButtonSetIncrements;
		^this.primitiveFailed
	}

	setRange {
		arg min, max;
		this.setRange_request(min, max);
		Async.wait
	}
	setRange_request {
		arg min, max;
		_prGtkSpinButtonSetRange;
		^this.primitiveFailed
	}

	getValue {
		this.getValue_request;
		^Async.wait
	}
	getValue_request {
		_prGtkSpinButtonGetValue;
		^this.primitiveFailed
	}

	getValueAsInteger {
		this.getValueAsInteger_request;
		^Async.wait
	}
	getValueAsInteger_request {
		_prGtkSpinButtonGetValueAsInteger;
		^this.primitiveFailed
	}

	setValue {
		arg value;
		this.setValue_request(value);
		Async.wait
	}
	setValue_request {
		arg value;
		_prGtkSpinButtonSetValue;
		^this.primitiveFailed
	}

	setUpdatePolicy {
		arg policy;
		this.setUpdatePolicy_request(policy);
		Async.wait
	}
	setUpdatePolicy_request {
		arg policy;
		_prGtkSpinButtonSetUpdatePolicy;
		^this.primitiveFailed
	}

	setNumeric {
		arg value;
		this.setNumeric_request(value);
		Async.wait
	}
	setNumeric_request {
		arg value;
		_prGtkSpinButtonSetNumeric;
		^this.primitiveFailed
	}

	setWrap {
		arg value;
		this.setWrap_request(value);
		Async.wait
	}
	setWrap_request {
		arg value;
		_prGtkSpinButtonSetWrap;
		^this.primitiveFailed
	}
	
	spin {
		arg type, amount;
		this.spin_request(type, amount);
		Async.wait
	}
	spin_request {
		arg type, amount;
		_prGtkSpinButtonSpin;
		^this.primitiveFailed
	}

	setSnapToTicks {
		arg value;
		this.setSnapToTicks_request(value);
		Async.wait
	}
	setSnapToTicks_request {
		arg value;
		_prGtkSpinButtonsetSnapToTicks;
		^this.primitiveFailed
	}

	update {
		this.update_request;
		Async.wait
	}
	update_request {
		_prGtkSpinButtonUpdate;
		^this.primitiveFailed
	}



	getDigits {
		this.getDigits_request;
		^Async.wait
	}
	getDigits_request {
		_prGtkSpinButtonGetDigits;
		^this.primitiveFailed
	}

	getIncrements {
		this.getIncrements_request;
		Async.wait
	}
	getIncrements_request {
		_prGtkSpinButtonGetIncrements;
		^this.primitiveFailed
	}

	getRange {
		this.getRange_request;
		^Async.wait
	}
	getRange_request {
		_prGtkSpinButtonGetRange;
		^this.primitiveFailed
	}

	getNumeric {
		this.getNumeric_request;
		^Async.wait
	}
	getNumeric_request {
		_prGtkSpinButtonGetNumeric;
		^this.primitiveFailed
	}

	getSnapToTicks {
		this.getSnapToTicks_request;
		^Async.wait
	}
	getSnapToTicks_request {
		_prGtkSpinButtongetSnapToTicks;
		^this.primitiveFailed
	}

	getUpdatePolicy {
		this.getUpdatePolicy_request;
		Async.wait
	}
	getUpdatePolicy_request {
		_prGtkSpinButtonGetUpdatePolicy;
		^this.primitiveFailed
	}

	getWrap {
		this.getWrap_request;
		^Async.wait
	}
	getWrap_request {
		_prGtkSpinButtonGetWrap;
		^this.primitiveFailed
	}

	// Extra

	*newIntWithRange {
		arg min = 0, max = 127, action;
		var spinner;

		spinner = this.newWithRange(min, max, 1);
		if (action.notNil, { spinner.connect('value-changed', action) });

		^spinner
	}
	*newFloatWithRange {
		arg min = 0, max = 127, step, action;
		var spinner;

		spinner = this.newWithRange(min, max, step);
		if (action.notNil, { spinner.connect('value-changed', action) });

		^spinner
	}
}
