GtkTreeStore : GtkTreeModel {
	*new {
		arg ... types;
		if (types.size == 0, { types = [\chararray] });
		this.newGtkTreeStore_request(types);
		^super.new.wrap(Async.wait)
	}
	*newGtkTreeStore_request {
		arg types;
		_prGtkTreeStoreNew;
		^this.primitiveFailed
	}

	remove {
		arg iter;
		this.remove_request(iter);
		if (Async.wait, {
			^iter
		}, {
			^nil
		});
	}
	remove_request {
		arg iter;
		_prGtkTreeStoreRemove;
		^this.primitiveFailed
	}

	append {
		arg parent;
		this.append_request(parent);
		^Async.wait;
	}
	append_request {
		arg parent;
		_prGtkTreeStoreAppend;
		this.primitiveFailed
	}

	setValue {
		arg iter, column, type, value;
		this.setValue_request(iter, column, type, value);
		Async.wait
	}
	setValue_request {
		arg iter, column, type, value;
		_prGtkTreeStoreSetValue;
		this.primitiveFailed
	}

	clear {
		this.clear_request;
		Async.wait
	}
	clear_request {
		_prGtkTreeStoreClear;
		this.primitiveFailed
	}

	insertBefore {
		arg parent, sibling;
		this.insertBefore_request(parent, sibling);
		^Async.wait
	}
	insertBefore_request {
		arg parent, sibling;
		_prGtkTreeStoreInsertBefore;
		this.primitiveFailed
	}

	insertAfter {
		arg parent, sibling;
		this.insertAfter_request(parent, sibling);
		^Async.wait
	}
	insertAfter_request {
		arg parent, sibling;
		_prGtkTreeStoreInsertAfter;
		this.primitiveFailed
	}
}
