InteractiveStream : Routine {
	var <>child, <>externalValue;
	*new {
		arg child, dieWithChild = true;
		var object;

		object = super.new({
			var value = \notNil, lastExternalValue;

			if (dieWithChild, {
				while({
					value.notNil
				}, {
					value = object.externalValue;
					object.externalValue = nil;
					if (value.notNil, {
						value.embedInStream;
					}, {
						value = object.child.value;
						value.embedInStream;
					});
				});
			}, {
				loop({
					value = object.externalValue;
					object.externalValue = nil;
					if (value.notNil, {
						lastExternalValue = value;
						value.embedInStream;
					}, {
						value = object.child.value;
						if (value.notNil, {
							value.embedInStream;
						}, {
							object.externalValue = object.externalValue ? lastExternalValue;
							loop({ object.externalValue.embedInStream });
						});
					});
				});
			})
		});
		
		object.child = child;

		^object
	}
}
