RoutineWithEnvironment : Routine {
	var <>environment;

	*new {
		arg function, environment;
		var obj;

		obj = super.new(function);
		obj.environment = environment ? currentEnvironment;
		^obj
	}

	next { arg inval; ^environment.use({ super.next(inval) }) }
	value { arg inval; ^environment.use({ super.value(inval) }) }

	prStart {
		arg inval;
		var result;

		result = environment.use({ func.value(inval) });

		// if the user's function returns then always yield nil
		nil.alwaysYield;
	}
}
