TimeStretchedStream : Routine {
	var <>child, <>time = 1.0, <>timefactor;
	*new {
		arg child, timefactor = 1.0;
		var object;

		object = super.new({
			arg dt;
			var lastValue = \notNil, timei, timef, value;

			loop({
				dt = dt * object.timefactor;

				object.time = object.time + dt;
				timei = object.time.asInteger;
				object.time = object.time.frac;

				if (timei > 0, {
					timei.do({ value = child.value });
					lastValue = value;
					dt = value.embedInStream ? 1.0;
				}, {
					dt = lastValue.embedInStream ? 1.0;
				});
				
				if (lastValue.isNil, { alwaysYield(nil) });
			});
		});
		
		object.child = child;
		object.timefactor = timefactor;

		^object
	}
}
