Timeout {
	var function, routine, <delay = nil, startTime, clock, aborted = false;
	*new {
		arg function, delay, clock;
		^super.new.initTimeout(function, delay, clock)
	}
	initTimeout {
		arg aFunction, aDelay, aClock;
		function = aFunction;
		clock = aClock ? SystemClock;
		if (aDelay.notNil, {
			this.delay = aDelay
		});
	}
	delay_ {
		arg value;	var ff;

		ff = {
			if (thisThread.seconds >= (startTime + delay), {
				function.value;
				delay = nil;
				startTime = nil;
			}, {
				delay = delay - (thisThread.seconds - startTime);
				startTime = thisThread.seconds;
				clock.sched(delay, ff);
			});
		};

		if (delay.isNil, {
			delay = value;
			startTime = thisThread.seconds;
			clock.sched(delay, ff);
		}, {
			if ((thisThread.seconds + value) > (startTime + delay), {
				startTime = thisThread.seconds;
				delay = value;
			}, {
				this.force;
			});
		});
	}
	abort {
		delay = nil;
		startTime = nil;
		aborted = true;
	}
	force {
		this.abort;
		function.value;
	}
}
