EnvelopePresets : Presets {
	asEnvelopeArray {
		arg i;			var data, amparray, timearray, envelope, style, yspec;

		data = this.at(i);
		if (data.notNil, {
			#envelope, style, yspec = data[1];

			yspec = yspec.asSpec;
			amparray = envelope.collect({ |point| yspec.map(point[1]) });
			timearray = Array.fill(envelope.size - 1, 0.0);
			envelope.doAdjacentPairs({ arg point1, point2, i; timearray[i] = point2[0] - point1[0] });

			^Env(amparray, timearray, style).asArray
		}, {
			^nil
		});
	}
}
