GtkConsoleInputView : GtkVBox {
	var console;
	var view, buffer, buttonBox;

	*new {
	      arg inConsole;
		^super.new(false, 0).init(inConsole);
	}
	init {
		arg inConsole;
		var scrolled;

		console = inConsole;

		scrolled = GtkScrolledWindow.new;
		scrolled.setPolicy(\automatic, \automatic);
		this.packStart(scrolled, true, true, 0);

		view = GtkTextView.new;
		scrolled.add(view);
		buffer = view.getBuffer;

		this.showAllChildren(true);
	}
}
