GtkMultipleEditorWindow : GtkWindow {
	var notebook;

	*new {
		arg inParent, inTitle, inViews, width = 800, height = 600;
		^super.new.initGtkMultipleEditorWindow(inParent, inTitle, inViews, width, height);
	}
	initGtkMultipleEditorWindow {
		arg inParent, inTitle, inViews, width, height;
		var title, view;

		this.setTitle(inTitle);
		this.setDefaultSize(width, height);
		this.setTransientFor(inParent);
		this.setDestroyWithParent(true);
		this.setPosition('center-on-parent');

		notebook = GtkNotebook.new;
		this.add(notebook);
	
		inViews.do({
			arg pair;

			title = pair.key;
			view = pair.value;

			notebook.appendPageWithText(view, title);
		});

		this.showAllChildren(true);
	}
}		
