GtkWidgetEnvironment : Environment {
	*new { ^super.new.initGtkWidgetEnvironment }
	initGtkWidgetEnvironment {
		this[\unnamed] = List[];
	}
	*make {	arg function; ^this.new.make(function) }
	make {
		arg function;
		super.make(function);
		this.refAll;
	}
	refAll {
		this.values.do({ |widget| if (widget.isKindOf(GtkWidget), { widget.ref }) } );
		this[\unnamed].do({ |widget| if (widget.isKindOf(GtkWidget), { widget.ref }) } );
	}
	unrefAll {
		this.values.do({ |widget| if (widget.isKindOf(GtkWidget) and: {widget.ptr.notNil}, { widget.unref }) } );
		this[\unnamed].do({ |widget| if (widget.isKindOf(GtkWidget) and: {widget.ptr.notNil}, { widget.unref }) } );
	}
	removeAllFromParent {
		this.values.do({ |object| if (object.isKindOf(GtkWidget), { object.removeFromParent }) });
		this[\unnamed].do({ |object| if (object.isKindOf(GtkWidget) , { object.removeFromParent }) });
	}
	clear {
		this.unrefAll;
		super.clear;
	}
	finalize { this.clear }

	pack {
		var packer;
	}
}
