+ ArrayedCollection {
	mutate {
		arg function;
		this.do({
			arg item, index;
			this.put(index, function.value(item));
		});
	}
}

+ String {
	toUpper {
		^this.mutate({arg item; item.toUpper})
	}
	toLower {
		^this.mutate({arg item; item.toLower})
	}

	trim {
		arg k;
		var index, t;

		k = k ? " \n";

		index = this.lastIndexForWhich({arg item, i; k.includes(item)});
		if (index.notNil, {
			t = this.copyToEnd(index + 1);
		}, {
			t = this.copy;
		});
		index = t.size - 1;
		while({index >= 0 && (k.includes(t.at(index)))}, { index = index - 1});
		^t.copyFromStart(index);
	}

	reverse {
		var newString;
		newString = String.new;
		this.reverseDo({arg c; newString = newString.add(c);});
		^newString;
	}
}
