XmlDoc {
	var <ptr;

	*new {
		arg version = "1.0";
		^super.new.init(version)
	}
	init {
		arg version;
		_prXmlDocNew;
		^this.primitiveFailed
	}
	
	*newFromFile {
		arg filename;
		^super.new.initFromFile(filename)
	}
	initFromFile {
		arg filename;
		_prXmlDocNewFromFile;
		^this.primitiveFailed
	}

	*newFromData {
		arg data;
		^super.new.initFromData(data)
	}
	initFromData {
		arg data;
		_prXmlDocNewFromData;
		^this.primitiveFailed
	}

	free {
		_prXmlDocFree;
		^this.primitiveFailed
	}

	save {
		var filename, indent = true;
		_prXmlDocSave
		^this.primitiveFailed
	}

	root {
		^XmlNode.wrap(this.ptr, this.prGetRootElement)
	}
	prGetRootElement {
		_prXmlDocGetRootElement;
		^this.primitiveFailed
	}

	createRoot {
		arg name;
		^XmlNode.wrap(this.ptr, this.prCreateRoot(name))
	}
	prCreateRoot {
		arg name;
		_prXmlDocCreateRootNode;
		^this.primitiveFailed
	}
}
